## snuffleupagus-0.5.0.tar.gz

=== Makefile ===
.DEFAULT_GOAL=help
.PHONY=help

clean:  ## clean everything
	make -C src clean
	cd src; phpize --clean

release:  ## compile with releases flags
	cd src; phpize
	cd src; ./configure --enable-snuffleupagus
	make -C src

install: release  ## compile and install snuffleupagus
	make -C src install

compile_debug:  ## compile a debug build
	cd src; phpize
	export CFLAGS="-g3 -ggdb -O1 -g"; cd src; ./configure --enable-snuffleupagus --enable-debug
	make -C src

debug: compile_debug ## compile and run a debug build
	TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C src test

coverage:  ## compile snuffleugpaus, and run the testsuite with coverage
	cd src; phpize
ifeq ($(CC),clang)
	cd src; CFLAGS="-fprofile-instr-generate -fcoverage-mapping" ./configure --enable-snuffleupagus
	make -C src
	LLVM_PROFILE_FILE="sp_%p_%m.profraw" TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C src test
	llvm-profdata-4.0 merge ./src/*.profraw -o ./src/sp.profdata
	llvm-cov report -instr-profile=./src/sp.profdata ./src/modules/snuffleupagus.so
else
	cd src; ./configure --enable-snuffleupagus --enable-coverage
	make -C src
	rm -Rf src/COV.html
	TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C src test
	lcov --base-directory ./src --directory ./src -c -o ./src/COV.info --rc lcov_branch_coverage=1 
	lcov --remove src/COV.info '/usr/*' --remove src/COV.info '*tweetnacl.c' -o src/COV.info --rc lcov_branch_coverage=1
	genhtml --show-details -o src/COV.html ./src/COV.info  --branch-coverage
endif

bench: joomla  ## run the benchmark

joomla:
	if [ ! -d "joomla-cms" ]; then \
		git clone --depth 1 https://github.com/joomla/joomla-cms.git >/dev/null; \
	fi
	cd joomla-cms; composer install >/dev/null 2>/dev/null
	echo "\nWith snuffleupagus:"
	cd joomla-cms; time php -d "extension=../src/modules/snuffleupagus.so" -d "sp.configuration_file=../config/default.rules" libraries/vendor/phpunit/phpunit/phpunit --no-coverage >/dev/null
	echo "\nWithout snuffleupagus:"
	cd joomla-cms; time php libraries/vendor/phpunit/phpunit/phpunit --no-coverage >/dev/null

packages: debian  ## produce packages

debian:
	dpkg-buildpackage -i -us -uc -tc -I -rfakeroot

help:
	@awk -F ':|##' '/^[^\t].+?:.*?##/ { printf "\033[36m%-30s\033[0m %s\n", $$1, $$NF }' $(MAKEFILE_LIST) | sort

.PHONY: debian

=== debian/changelog ===
snuffleupagus (0.5.0) UNRELEASED; urgency=medium

  [ kkadosh ]
  * Tighten a bit a command-injection prevention rule in the default rules set
  * Increased the portability of the testsuite
  * Improved documentation
  * Usual code cleanup
  * Snuffleupagus will throw an informative error when compiled for PHP5
  * Snuffleupagus will throw an informative error when compiled for PHP5
  * The testsuite is now run on Alpine, Fedora, Debian and Ubuntu
  * Some rules against now-known vulnerabilities/techniques were added
  * PHP7.4 is fully supported, without any compilation warning
  * Snuffleupagus can now be used with PHP compiled without sessions support as a builtin (which is the case on Alpine)
  * Fix a compilation warning on FreeBSD
  * Cookies hardening is now supported on PHP7.3+


 -- kkadosh <snuffleupagus@nbs-system.com>  Wed, 12 Jun 2019 16:40:00 +0200

snuffleupagus (0.4.1) UNRELEASED; urgency=medium

  [ kkadosh ]
  * Improve and clarify the documentation
  * Add support for PHP7.3
  * Improve the coverage, we have now reached 99% of coverage
  * Improve the `mb_string` hooking logic 
  * The script that check uploaded file is now available in PHP
  * Fix segfault on 32-bit for PHP7.3
  * Fix segfault when using `sloppy_comparison` feature with array


 -- kkadosh <snuffleupagus@nbs-system.com>  Fri, 21 Dec 2018 11:50:00 +0200

snuffleupagus (0.4.0) UNRELEASED; urgency=medium

  [ jvoisin ]
  * Add the possibility to whitelist `stream wrappers`
  * Snuffleupagus is now using php's logging mechanisms, instead of outputting its log directly into the syslog.
  * PHP is now prevented from ever disabling certificate verification thanks to a few lines in our default configuration.
  * Significant code simplification for cookies handling
  * Our `sloppy comparison` feature is now complete
  * Snuffleupagus won't start with an invalid config anymore, except if the `sp.allow_broken_configuration` is set.
  * It's now possible to place virtual-patches on the return value of user-defined functions.
  * Since Snuffleupagus is used by more and more organisations, we added a bunch of them in our propaganda page.
  * Add some missing pieces of documentation and fix some links
  * Fix the `make install` command
  * Fix various compilation warnings
  * Snuffleupagus is now running on platforms that aren't using the glibc

 -- jvoisin <snuffleupagus@nbs-system.com>  Fri, 31 Aug 2018 16:50:00 +0200

snuffleupagus (0.3.1) UNRELEASED; urgency=medium

  * Disable XXE and harden PRNG by default
  * Use SameSite on PHP's session cookie in the default rules
  * Relax a bit what files can be included in the default rules  
  * Add the possibility to ignore files hashes when generating rules
  * The filename filter is now accepting phar paths  
  * The harden rand_feature is not ignoring parameters anymore in function calls
  * Fix possible crashes/hangs when using php-fpm's pools  
  * Fix an infinite loop on echo hook
  * Fix an issue with filename filter
  * Fix some documentation issues
  * Fix the Arch Linux's PKGBUILD

 -- he2ss <snuffleupagus@nbs-system.com>  Tue, 20 Aug 2018 15:00:00 +0200

snuffleupagus (0.3.0) UNRELEASED; urgency=medium

  * Session cookies can now be encrypted
  * Some occurrences of type juggling can now be eradicated
  * It's now possible to hook echo and print
  * The .filename() filter is now matching on the file where the function is called instead on the one where it's defined.
  * Vastly optimize the way native functions are hooked
  * The format of the logs has been streamlined to ease their processing
  * Better handling of filters for built-in functions
  * Fix various possible integer overflows
  * Fix an annoying memory leak

 -- kkadosh <snuffleupagus@nbs-system.com>  Tue, 17 Jul 2018 15:00:00 +0200

snuffleupagus (0.2.2) UNRELEASED; urgency=medium
  * Add some assertions in the code
  * The `.dump()` filter is now supported for `unserialize`, `readonly_exec`, and `eval` black/whitelist
  * Add more rules examples
  * Provide a script to check for malicious file uploads
  * Significant performances improvement (at least +20%)
  * Significantly improve the performances of our default rules set
  * Our readme file is now shinier
  * Minor code simplification
  * Fix a crash related to variadic functions

 -- jvoisin <snuffleupagus@nbs-system.com>  Tue, 12 Mar 2018 10:00:00 +0200

snuffleupagus (0.2.1) UNRELEASED; urgency=medium
  * The testsuite can now be successfully run as root
  * Fix a double execution when snuffleupagus is used with some other extensions
  * Fix an execution-context related crash
  * Support PCRE2, since it's required for PHP7.3
  * Improve a bit the portability of the code
  * Minor code simplification

 -- jvoisin <snuffleupagus@nbs-system.com>  Tue, 07 Feb 2018 11:00:00 +0200

snuffleupagus (0.2.0) UNRELEASED; urgency=medium

  * Glob support in `sp.configuration_file`
  * Whitelist/blacklist functions in `eval`
  * `phpinfo` shows is the configuration is valid or not
  * Off-by-one in configuration parsing fixed
  * Minor cookie-encryption related memory leaks fixes
  * Various crashes fixes
  * Configuration files with windows EOL are correctly handled
  * General code clean-up
  * Documentation overhaul
  * Compilation on FreeBSD and CentOS
  * Select which cookies to encrypt via regular expressions
  * Match on return values from user-defined functions
  * Simplification and clean up of our linked-list implementation

 -- jvoisin <snuffleupagus@nbs-system.com>  Tue, 18 Jan 2018 13:00:00 +0200

snuffleupagus (0.1.0) UNRELEASED; urgency=medium

  * Initial release.

 -- jvoisin <snuffleupagus@nbs-system.com>  Tue, 04 Jul 2017 17:51:31 +0200

=== APKBUILD ===
# Maintainer: <secu@nbs-system.com>
pkgname="php7-snuffleupagus"
_pkgname="snuffleupagus"
pkgver=0.1
pkgrel=1
pkgdesc="Snuffleupagus module for PHP7."
url="https://snuffleupagus.readthedocs.io"
arch="all"
license="LGPL3"
depends="php7-dev php7-fpm"
source=""

_giturl="https://github.com/nbs-system/snuffleupagus.git"

prepare() {
  default_prepare
  # Use tarball instead of git for release.
  # https://wiki.alpinelinux.org/wiki/Creating_an_Alpine_package#APKBUILD_variables.2Ffunctions
  git clone "${_giturl}" "${srcdir}/${_pkgname}" || return 1
}

build() {
  cd "${srcdir}/${_pkgname}/src"
  phpize || return 1
  ./configure --prefix=/usr --enable-"${_pkgname}" || return 1
  make || return 1
}

check() {
  NO_INTERACTION=1 REPORT_EXIT_STATUS=1 make -C "${srcdir}/${_pkgname}/src" test
}

package() {
  make -C "${srcdir}/${_pkgname}/src" INSTALL_ROOT="${pkgdir}" install || return 1
  install -D -m644 "${srcdir}/${_pkgname}/config/default.rules" "${pkgdir}/etc/php/conf.d/${_pkgname}.rules" || return 1
  install -D -m644 "${srcdir}/${_pkgname}/config/${_pkgname}.rules" "${pkgdir}/etc/php7/conf.d/${_pkgname}.rules" || return 1
}

=== PKGBUILD ===
# Maintainer NBS System Security Team <secu@nbs-system.com>
pkgname="snuffleupagus"
pkgver=r169.424845a
pkgrel=1
pkgdesc="Security module for PHP7."
url="https://snuffleupagus.readthedocs.io"
arch=('i686' 'x86_64')
license=('LGPL3')
depends=('php' 'php-fpm')
checkdepends=()
source=("${pkgname}::git+https://github.com/nbs-system/${pkgname}.git")
md5sums=('SKIP')

pkgver() {
  cd "${srcdir}/${pkgname}"
  printf "r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

build() {
  cd "${srcdir}/${pkgname}/src"
  phpize
  ./configure --prefix=/usr --enable-"${pkgname}"
  make
}

check() {
  NO_INTERACTION=1 REPORT_EXIT_STATUS=1 make -C "${srcdir}/${pkgname}/src" test
}

package() {
  make -C "${srcdir}/${pkgname}/src" INSTALL_ROOT="${pkgdir}" install
  install -D -m644 "${srcdir}/${pkgname}/config/default.rules" "${pkgdir}/etc/php/conf.d/${pkgname}.rules"
  install -D -m644 "${srcdir}/${pkgname}/config/${pkgname}.ini" "${pkgdir}/etc/php/conf.d/${pkgname}.ini"
}

=== debian/control ===
Source: snuffleupagus
Priority: optional
Maintainer: NBS System <snuffleupagus@nbs-system.com>
Build-Depends: debhelper (>= 9), php7.0-dev | php7.1-dev | php7.2-dev
Standards-Version: 4.1.3
Homepage: https://snuffleupagus.fr
Section: php
Vcs-Git: https://github.com/nbs-system/snuffleupagus

Package: snuffleupagus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Hardening for your php7 stack
	Snuffleupagus is cool

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory src --with php

override_dh_auto_clean:
	cd ./src; phpize --clean

override_dh_auto_configure:
	cd ./src; phpize
	cd ./src; ./configure --enable-snuffleupagus

override_dh_auto_install:
	dh_testdir
	dh_testroot
	dh_installdirs
	mkdir -p debian/snuffleupagus/$$(/usr/bin/php-config --extension-dir)/
	mkdir -p debian/snuffleupagus/etc/php/$$(/usr/bin/php-config --version | cut -d '.' -f1-2)/mods-available/
	install -m 644 -o root -g root src/modules/snuffleupagus.so debian/snuffleupagus/$$(/usr/bin/php-config --extension-dir)/snuffleupagus.so
	install -m 644 -o root -g root config/snuffleupagus.ini debian/snuffleupagus/etc/php/$$(/usr/bin/php-config --version | cut -d '.' -f1-2)/mods-available/snuffleupagus.ini
 
override_dh_auto_test:
	TEST_PHP_ARGS="-q" REPORT_EXIST_STATUS=1 make -C src test

=== debian/watch ===
version=3
https://github.com/nbs-system/snuffleupagus/tags /nbs-system/snuffleupagus/archive/snuffleupagus-([0-9.]+)\.tar\.(gz|xz|bz2)
